' ---------------------------------------------------------------------------
'
' Heizgriffsteuerung fr Motorrder o.. Anwendungen V 1.1 von A. Rutenberg
'
' ---------------------------------------------------------------------------
' Die ganze Schaltung besteht im Wesentlichen aus zwei Tasten und einer 10er LED-Zeile und einer
' MOS-FET-Stufe. Fr die LEDs sind Treiber eingebaut.
'
' --- Betriebssystem konfigurieren ------------------------------------------
include "om.def"           ' Definitionen fuer Betriebssystem
option openmini
pullupa = 0
pullupb = 0
ClockDis = on
' ---------------------------------------------------------------------------

RunOnErr = on                      ' bei Fehler Programm neu starten
define PWM_Port            port[1] ' 1. PWM Ausgang
define spannung            AD[2]   ' Spannungskontrollport
define Led1                port[4]
define Led2                port[5]
define Led3                port[6]
define Led4                port[9] ' Die Open-Mini besitzt wie die Open-Micro
define Led5                port[10]' den PORTA und zustzlich den PORTB.
define Led6                port[11]
define Led7                port[12]
define Led8                port[15]
define Tasterauf           port[13]' Taste hher
define Tasterunter         port[14]' Taste niedriger
define blank               port[16]' zum halbhell/dunkelsteuern der uersten LEDs
define Bit81_88            byte[11]' byte 11 (statische Bits 81 bis 88)
define Flanke1             Bit[81] ' Flankenbit Taste rauf
define Flanke2             Bit[82] ' Flankenbit Taste runter
define tmp                 byte    ' Hilfsvariable fr PWM
define a                   byte    ' Zhlervariable
define t                   byte    ' Zhlervariable
define x                   byte    ' Timervariable
define y                   byte    ' Zhlervariable Ende-Timer


'   Die Pinbelegung der
'    Open-Mini (QY4)
'              _____    _____
'             |     \__/     |
'            [  VDD      GND  ]       VDD = 4.6 bis 5.5 Volt
'             |              |
' blank      [  PTB7    PTB0  ]       LED 4
'             |              |
' LED 8      [  PTB6    PTB1  ]       LED 5
'             |              |
' LED 3      [  PTA5    PTA0  ]       PWM1
'             |              |
' LED 2      [  PTA4    PTA1  ]       PWM2
'             |              |
' Tasterauf  [  PTB5    PTB2  ]       LED 6
'             |              |
' Tasterunter[  PTB4    PTB3  ]       LED 7
'             |              |
' LED 1      [  PTA3    PTA2  ]       host/run
'             |______________|
'

' ---Initialisierung---------------------------------------------------------

#init
tmp = 0
a = 1
t = 0
x = 0                                      ' Variable fr Timer
y = 0                                      ' Variable fr Ende-Timer
if Tasterauf then goto setz1               ' Taste gedrckt? Ja, dann setze EIN-Flanke
Flanke1 = 0                                ' FlankenBit off setzen
if Tasterunter then goto setz2             ' Taste gedrckt? Ja, dann setze EIN-Flanke
Flanke2 = 0                                ' FlankenBit off setzen
goto initend                               ' Reset Ein-Flanke (bei Nichtbettigung der Taste)
#setz1
if Flanke1 then goto error                 ' Ein-Flanke gesetzt? Ja, dann Ende
Flanke1 = on                               ' Setze Ein-Flanke (Sperre fr weiteres Setzen)
goto init
#setz2
if Flanke2 then goto error                 ' Ein-Flanke gesetzt? Ja, dann Ende
Flanke2 = on                               ' Setze Ein-Flanke (Sperre fr weiteres Setzen)
goto init
#initend
                                           'weiter gehts
' ---Hauptprogramm-----------------------------------------------------------

#start
' Beginn mit Prfung auf Unterspannung und nachfolgendem Vorheizen der Griffe
if spannung < 175 then goto unterspannung  ' Prfung  Batterie <11 Volt
if Tasterauf then goto setz3               ' Taste gedrckt? Ja, dann setze EIN-Flanke
Flanke1 = 0                                ' FlankenBit off setzen
if Tasterunter then goto setz4             ' Taste gedrckt? Ja, dann setze EIN-Flanke
Flanke2 = 0                                ' FlankenBit off setzen
goto start                                 ' Reset Ein-Flanke (bei Nichtbettigung der Taste)
#setz3
if Flanke1 then goto vorheizen             ' Ein-Flanke gesetzt? Ja, dann Ende
Flanke1 = on                               ' Setze Ein-Flanke (Sperre fr weiteres Setzen)
goto start
#setz4
if Flanke2 then goto vorheizen             ' Ein-Flanke gesetzt? Ja, dann Ende
Flanke2 = on                               ' Setze Ein-Flanke (Sperre fr weiteres Setzen)
goto start                                 ' Rcksprung zu start

#start1
' Startpunkt des laufenden Programms
x = Timer                                  ' setzt x auf Timerabfrage (Timer zhlt automatisch hoch)
#start2
if spannung < 175 then goto unterspannung1 ' Prfung Unterspannung <11 Volt bei Fehler der Lichtmaschine
if Tasterauf then goto rauf                
Flanke1 = 0
if Tasterunter then goto runter
Flanke2 = 0
if Timer = (x + 200) then goto start3      ' 4 Sekunden Pause vor dem Abschalten der LEDs - Tastenbettigung ist mglich
goto start2
#start3
led1 = 0                                   ' alle LEDs ausschalten
led2 = 0                                   ' alle LEDs ausschalten
led3 = 0                                   ' alle LEDs ausschalten
led4 = 0                                   ' alle LEDs ausschalten
led5 = 0                                   ' alle LEDs ausschalten
led6 = 0                                   ' alle LEDs ausschalten
led7 = 0                                   ' alle LEDs ausschalten
led8 = 0                                   ' alle LEDs ausschalten
blank = 0                                  ' Grenz-LEDs ausschalten
goto start1                                ' Rcksprung zum Start

' ---Unterprogramme---------------------------------------------------------

#vorheizen
' signalisiert durch hochlaufende LEDs ber 30 Sekunden
gosub pwm_start                       ' PWM-Routine Port1 einschalten
tmp = 250                             ' Verbraucher mit 100% vorheizen
pwm1 tmp                              ' Datenzuweisung fr PWM
for t = 0 to 15                         ' Zhler fr 6 komplette LED-Durchlufe, ergibt 90 Sekunden
x = Timer                               ' setzt X auf Timer, Timer zhlt automatisch hoch
y = Timer                               ' setzt y auf Timer, Timer zhlt automatisch hoch
#schleife
b = 0                                   ' Rcksetzen der Vergleichsvariablen
c = 0                                   ' Rcksetzen der Vergleichsvariablen
blank = on                              ' Grenz-LEDs einschalten
if Timer = x then led1 = on             ' LED einschalten
if Timer = x + 5 then led2 = on         ' nchste LED nach 0,1 Sekunden
if Timer = x + 10 then led3 = on        ' nchste LED nach 0,1 Sekunden
if Timer = x + 15 then led4 = on        ' nchste LED nach 0,1 Sekunden
if Timer = x + 20 then led5 = on        ' nchste LED nach 0,1 Sekunden
if Timer = x + 25 then led6 = on        ' nchste LED nach 0,1 Sekunden
if Timer = x + 30 then led7 = on        ' nchste LED nach 0,1 Sekunden
if Timer = x + 35 then led8 = on        ' nchste LED nach 0,1 Sekunden
if Timer = x + 40 then led1 = off       ' LED ausschalten
if Timer = x + 40 then led2 = off       ' LED ausschalten
if Timer = x + 40 then led3 = off       ' LED ausschalten
if Timer = x + 40 then led4 = off       ' LED ausschalten
if Timer = x + 40 then led5 = off       ' LED ausschalten
if Timer = x + 40 then led6 = off       ' LED ausschalten
if Timer = x + 40 then led7 = off       ' LED ausschalten
if Timer = x + 40 then led8 = off       ' LED ausschalten
if Timer = x + 50 then x = Timer        ' Timer auf X-Wert setzen
if Timer = y + 250 then goto weiter     ' prfen y = 5 Sekunden (alle LED-Durchlufe absolviert)
if spannung < 160 then b = 1            ' Prfen auf Unterspannung und setzen Variable bei Ereignis
pause 10                                ' Prfpause
if spanung < 160 then c = 1             ' 2. Prfung Unterspannung und setzen 2. Variable bei Ereignis
if b and c = 1 then goto unterspannung1 ' Abbruch Anheizen und Rckkehr zu start
if spannung > 240 then b = 2            ' Prfen auf berspannung und setzen Variable bei Ereignis
pause 10                                ' Pfpause
if spanung > 240 then c = 2             ' Prfen auf berspannung und setzen Variable bei Ereignis
if b and c = 2 then goto ueberspannung1 ' Abbruch Anheizen und Rckkehr zu start
goto schleife                           ' sind nicht alle Durchlufe absolviert, dann von vorn
#weiter
if Tasterunter then goto start1         ' Vorheizen Abbruch und Sprung zum Normalbetrieb
if Tasterauf then goto start1           ' Vorheizen Abbruch und Sprung zum Normalbetrieb
a = 6
if t = 15 then goto anzeige           ' nach Ablauf der Schleifen Rcksprung ber Anzeige zu start1
next                                  ' nchster Schritt

#rauf
' erhhen der Tastendruck-Zhlers um 1 bis zum Maximum
if Flanke1 then goto rauf1            ' Ein-Flanke gesetzt? Ja, dann Ende
Flanke1 = on                          ' Setze Ein-Flanke (Sperre fr weiteres Setzen)
if a = 8 then goto start1             ' Wenn der Zhler = 8 ist wird das Unterprogramm verlassen
a = a + 1                             ' Erhhung des Zhlers um 1
#rauf1
goto anzeige

#runter
' erniedrigen des Tastendruck-Zhlers um 1 bis Minimum
if Flanke2 then goto runter1          ' Taste gedrckt? Ja, dann setze EIN-Flanke
Flanke2 = on                          ' Reset Ein-Flanke (bei Nicthbettigung der Taste)
if a = 1 then goto start1             ' Wenn der Zhler = 0 ist wird das Unterprogramm verlassen
a = a - 1                             ' Erniedrigung des Zhlers um 1
#runter1
goto anzeige

#anzeige
' signalisiert durch jeweils leuchtende LED
blank = on                 ' schaltet die beiden uersten LEDs auf halbe Helligkeit
if a = 1 then led1 = on    ' LED1 an
if a = 1 then tmp = 0      ' PWM Port 0%
if a = 1 then led2 = 0     ' wenn LED 1 on ist, dann kann LED2 nicht on sein
if a = 2 then led2 = on    ' LED2 an
if a = 2 then tmp = 36     ' PWM Port 14%
if a = 2 then led1 = 0     ' wenn LED 2 on ist, dann kann LED1 nicht on sein
if a = 2 then led3 = 0     ' wenn LED 2 on ist, dann kann LED3 nicht on sein
if a = 3 then led3 = on    ' LED3 an
if a = 3 then tmp = 72     ' PWM Port 29%
if a = 3 then led2 = 0     ' wenn LED 3 on ist, dann kann LED2 nicht on sein
if a = 3 then led4 = 0     ' wenn LED 3 on ist, dann kann LED4 nicht on sein
if a = 4 then led4 = on    ' LED4 an
if a = 4 then tmp = 108    ' PWM Port 43%
if a = 4 then led3 = 0     ' wenn LED 4 on ist, dann kann LED3 nicht on sein
if a = 4 then led5 = 0     ' wenn LED 4 on ist, dann kann LED5 nicht on sein
if a = 5 then led5 = on    ' LED5 an
if a = 5 then tmp = 144    ' PWM Port 58%
if a = 5 then led4 = 0     ' wenn LED 5 on ist, dann kann LED4 nicht on sein
if a = 5 then led6 = 0     ' wenn LED 5 on ist, dann kann LED6 nicht on sein
if a = 6 then led6 = on    ' LED6 an
if a = 6 then tmp = 180    ' PWM Port 72%
if a = 6 then led5 = 0     ' wenn LED 6 on ist, dann kann LED5 nicht on sein
if a = 6 then led7 = 0     ' wenn LED 6 on ist, dann kann LED7 nicht on sein
if a = 7 then led7 = on    ' LED7 an
if a = 7 then tmp = 216    ' PWM Port 86%
if a = 7 then led6 = 0     ' wenn LED 7 on ist, dann kann LED6 nicht on sein
if a = 7 then led8 = 0     ' wenn LED 7 on ist, dann kann LED8 nicht on sein
if a = 8 then led8 = on    ' LED8 an
if a = 8 then tmp = 250    ' PWM Port 100%
if a = 8 then led7 = 0     ' wenn LED 8 on ist, dann kann LED7 nicht on sein
pwm1 tmp                   ' Datenzuweisung PWM-Port1
goto start1                ' Rcksprung in das Hauptprogramm start1

#error
' signalisiert durch LED 4 und 5 blinkend
blank = on                 ' Grenz-LEDs an
led4 = on                  ' LED4 einschalten
led5 = on                  ' LED5 einschalten
pause 12                   ' 1/4 Sekunde Pause
blank = 0                  ' Grenz-LEDs aus
led4 = 0                   ' LED4 ausschalten
led5 = 0                   ' LED5 ausschalten
pause 12                   ' 1/4 Sekunde Pause vor dem Rcksprung
goto init                  ' Rcksprung zu init

#unterspannung
' signalisiert durch schnell blinkende LED 1 und 8
pwm1_aus                   ' PWM-Routine Port1 ausschalten
blank = on                 ' Grenz-LEDs an
led1 = on                  ' LED1 an
led8 = on                  ' LED8 an
pause 6                    ' 1/8 Sekunde Pause
blank = 0                  ' Grenz-LEDs aus
led1 = 0                   ' LED1 aus
led8 = 0                   ' LED8 aus
pause 6                    ' 1/8 Sekunde Pause vor dem Rcksprung
goto start                 ' Rcksprung zum start

#unterspannung1
' signalisiert durch schnell blinkende LED 1 und 8
a = 1
blank = on                 ' Grenz-LEDs an
led1 = on                  ' LED1 an
led8 = on                  ' LED8 an
pause 6                    ' 1/8 Sekunde Pause
blank = 0                  ' Grenz-LEDs aus
led1 = 0                   ' LED1 aus
led8 = 0                   ' LED8 aus
pause 6                    ' 1/8 Sekunde Pause vor dem Rcksprung
goto anzeige               ' Rcksprung zur anzeige
end                        ' Programmende

' ---------------------------------------------------------------------------
' --- PWM-Routinen fr Port1 ------------------------------------------------
' ---------------------------------------------------------------------------
TABLE pwm1_ein byte    ' PWM Port1 einschalten
  &h12 &h06
  &h1a &h20 &h18 &h20 &h3f &h26 &h3f &h27 &ha6 &h1a &hb7 &h25 &h1b &h20 &h81
TABEND
' ---------------------------------------------------------------------------
TABLE pwm1 byte        ' PWM Port1 setzten - Uebergabe als Argument
  &h12 &h06
  &had &h13 &ha1 &hfa &h25 &h03 &h10 &h25 &h81 &h5f &h48 &h59 &h48 &h59 &hbf &h26
  &hb7 &h27 &h11 &h25 &h81 &hae &h01 &h83
TABEND
' ---------------------------------------------------------------------------
TABLE pwm1_aus byte    ' PWM Port1 ausschalten
  &h12 &h06
  &h1a &h20 &h18 &h20 &h3f &h25 &h1b &h20 &h81
TABEND
' ---------------------------------------------------------------------------

